//ER02-0001 napr. rew. 2004
//designed by:  Marcin Osiniak & Mateusz Nowaczyk
//assembled by: Marcin Osiniak & Mateusz Nowaczyk
//C code by:    Marcin Osiniak & Mateusz Nowaczyk
//ASM code by:  Marcin Osiniak

//kwarc 11,0592MHz

#include "at89s8252.h"

sbit at 0x90 light;	//P1_0
sbit at 0x92 ladow;	//P1_2
sbit at 0x91 lizer;	//P1_1
sbit at 0x93 led_r;	//P1_3
sbit at 0x94 led_g;	//P1_4

sbit at 0xB1 NE555;	//P3_1
sbit at 0xB2 foto2;	//P3_2
sbit at 0xB3 foto1;	//P3_3
sbit at 0xB7 LCDen; //P3_7
sbit at 0xB5 LCDrs; //P3_5

sbit at 0x80 LM_p1;	//P0_0
sbit at 0x81 LM_p7;	//P0_1
sbit at 0x83 klucz; //P0_3
sbit at 0x84 guzik; //P0_4
sbit at 0x85 klaw1;	//P0_5
sbit at 0x86 klaw2;	//P0_6
sbit at 0x87 klaw3;	//P0_7

unsigned  int overflow = 0;										//licznik przerwan timera predkosci i sekundnika
unsigned char vel_disp = 0;										//zezwolenie na wyswietlenie wyniku pomiaru V
unsigned  int ov1_beep = 0;										//licznik przerwan timera sygnalizacyjnego
unsigned  int ov2_beep = 0;										//licznik przerwan timera sygnalizacyjnego
unsigned  int ov3_beep = 0;
unsigned char tr1_mode = 0;										//tryb pracy TR1 timer/miernik V
unsigned char liz_tmp1;
unsigned char klawisze;
unsigned char blk_beep = 0;										//zezwolenie na przerywanie buczka
unsigned char blk_disp = 0;										//zezwolenie na mruganie wyswietlacza
unsigned char blk_ledr = 0;										//zezwolenie na mruganie czerwona dioda
unsigned char blk_en57 = 0;										//zezwolenie na sygnal naladowanego kondensatora
unsigned char led_time = 0;
unsigned char tmp_dspl = 0;
		 char hou_time = 0; 
		 char min_time = 0;
		 char sec_time = 0;
unsigned char LCD_buff [8];										//bufor wyswietlacza LCD

void delay (unsigned char time)									//opoznienie w ms dla kwarcu 11,0592MHz
{
	_asm;
			mov		   r0, dpl
	00001$:	mov		   r1, #0x60								//dla innego kwarcu nalezy zmienic liczbe 0x60
	00002$:	nop
			nop
			nop
			nop
			nop
			nop
			djnz	   r1, 00002$
			djnz	   r0, 00001$
	_endasm;
}

void keyscan ()
{
	_asm;
			mov _klawisze, #0x00

			jb     _klaw1, 20001$
			jnb    _klaw2, 20001$
			jnb    _klaw3, 20001$
			mov _klawisze, #0x01
	20001$: jb     _klaw1, 20005$
			jnb    _klaw2, 20005$
			jb     _klaw3, 20005$
			mov _klawisze, #0x05
	20005$:	jb     _klaw1, 20004$
			jb     _klaw2, 20004$
			jnb    _klaw3, 20004$
			mov _klawisze, #0x04
	20004$:	jnb    _klaw1, 20002$
			jb     _klaw2, 20002$
			jnb    _klaw3, 20002$
			mov _klawisze, #0x02
	20002$: jnb    _klaw1, 20003$
			jnb    _klaw2, 20003$
			jb     _klaw3, 20003$
			mov _klawisze, #0x03
	20003$: jnb    _klaw1, 20006$
			jb     _klaw2, 20006$
			jb     _klaw3, 20006$
			mov _klawisze, #0x06
	20006$:
	_endasm;
}

void lcdscode (unsigned char sbyte)								//wyslij rozkaz do sterownika wyswietlacza
{
	_asm;
			clr	   _LCDrs
			setb   _LCDen
			mov		   P2, dpl
			clr	   _LCDen
			mov		  dpl, #0x02
			lcall          _delay
	_endasm;
}

void LCDclear ()												//wyczysc wyswietlacz
{
	lcdscode (0x01);
	delay (2);
	lcdscode (0x0C);
	lcdscode (0x06);
	delay (2);
}

void lcdwrite_buff ()											//wypisz zawartosc buforu na wyswietlaczu
{
	_asm;
			mov		  dpl, #0x80								//ustaw parametr podprogramu lcdscode (kursor na 0)
			lcall		   _lcdscode							//wywolaj podprogram lcdscode - wyslij rozkaz do LCD
			setb   _LCDrs										//przestaw LCD w tryb odbioru danych, a nie rozkazow
			clr         a										//wyzeruj akumulator
	00003$: mov        r2, a									//zachowaj w rejestrze r2 wartosc akumulatora
			setb   _LCDen										//ustaw linie ENABLE wyswietlacza w stan wyskoi
			add         a, #_LCD_buff							//oblicz i umiesc w akumulatorze adres
			mov        r0, a									//przenies do r0 obliczony wczesniej adres
			mov        P2, @r0									//wyslij odpowiednia komorke buforu do LCD
			clr    _LCDen										//wypisz znak na wyswietlaczu
			mov         a, r2									//przywroc zachowana wczesniej wartosc akumulatora
			mov       dpl, #0x01								//ustaw parametr podprogramu delay
			lcall          _delay								//wykonaj delay - czekaj dpl milisekund
			inc         a										//zwieksz licznik i automatycznie adres
			cjne        a, #0x08, 00003$						//przestan powtarzac, gdy wyswietlono osmy znak
	_endasm;
}

void lcdwrite_text (char *text_ptr)								//wypisz ciag znakow o poczatku w text_ptr
{
	_asm;
			push      dpl										//zachowaj na stosie dpl - czesc adresu tekstu
			mov		  dpl, #0x80								//ustaw parametr podprogramu lcdscode (kursor na 0)
			lcall		   _lcdscode							//wywolaj podprogram lcdscode - wyslij rozkaz do LCD
			pop       dpl										//odczytaj zachowana wczesniej wartosc dpl
			setb   _LCDrs										//przestaw LCD w tryb odbioru danych, a nie rozkazow
			mov         b, #0x00								//wyzeruj rejestr bazowy
	00004$:	mov         a, b									//zaladuj akumulator przesunieciem na kolejny znak
			setb   _LCDen										//ustaw linie ENABLE wyswietlacza w stan wyskoi
			movc		a, @a+dptr								//odczytaj z pamieci programu znak
			mov		   P2, a									//wyslij odczytany znak do LCD
			clr    _LCDen										//wypisz znak na wyswietlaczu
			inc         b										//zwieksz o jeden numer znaku do wyswietlenia
			push      dpl										//zachowaj obecna wartosc wskaznika tekstu
			mov       dpl, #0x01								//ustaw parametr podprogramu delay
			lcall          _delay								//wykonaj delay - czekaj dpl milisekund
			pop       dpl										//przywroc zachowana wartosc wskaznika tekstu
			jnz    00004$										//powtarzaj gdy nie odczytano 0
	_endasm;
}

void lightwait ()
{
	unsigned int tmp_wait;
	liz_tmp1 = lizer;
	for (tmp_wait = 0; tmp_wait < 1501; ++tmp_wait)
	{
		delay (1);
		while (klucz == 1)
		{
			led_g = 0;
			lizer = 0;
			light = 0;
		}
		lizer = liz_tmp1;
		led_g = 1;
		light = 1;
	}
	light = 0;
}

void LCDtime ()													//dokonaj konwersji czasu i wyswietl go na LCD
{
	_asm;
			mov		    a, _hou_time							//przlicz h na cyfry; wynik do bufora
			mov		    b, #0x0A								//umiesc w rejestrze bazowym wartosc 10
			div		   ab										//podziel licznik godzin przez 10
			mov			a, b									//przenies do akumulatora reszte z dzielenia
			add			a, #0x30								//przekonwertuj cyfre na jej kod ASCII
			mov		   r0, #_LCD_buff							//umies w r0 adrers pierwszej komorki buforu
			inc        r0										//ustaw adres na druga komorke buforu
			mov       @r0, a									//wpisz w bufor kod ASCII cyfry jednosci godzin
			mov			a, _min_time							//przlicz m na cyfry; wynik do bufora
			mov			b, #0x0A
			div			ab
			add			a, #0x30
			inc        r0
			inc        r0
			mov       @r0, a
			mov			a, b
			add			a, #0x30
			inc        r0
			mov       @r0, a
			mov			a, _sec_time							//przlicz s na cyfry; wynik do bufora
			mov			b, #0x0A
			div			ab
			add			a, #0x30
			inc        r0
			inc        r0
			mov       @r0, a
			mov			a, b
			add			a, #0x30
			inc        r0
			mov       @r0, a
			lcall          _lcdwrite_buff
	_endasm;
}

void settimer ()
{
	light = 1;
	LCD_buff[0] = '0';
	LCD_buff[2] = ':';
	LCD_buff[5] = ':';
	LCDtime ();
	keyscan ();
	while (klawisze != 5)
	{
		while (klucz == 1)										//zatrzymaj jak nie ma klucza
		{
			light = 0;
			led_g = 0;
		}
		if (blk_disp == 0) light = 1;							//nie wlaczaj light jak light ma migac
		led_g = 1;
		keyscan ();
		if (klawisze == 2)
		{
			++hou_time;
			if (hou_time == 10) hou_time = 0;
			delay (200);
			LCDtime ();
		}
		if (klawisze == 3)
		{
			++min_time;
			if (min_time == 60) min_time = 0;
			delay (200);
			LCDtime ();
		}
		if (klawisze == 4)
		{
			++sec_time;
			if (sec_time == 60) sec_time = 0;
			delay (200);
			LCDtime ();
		}
	}
	delay (25);													//czekaj z powodu drgajacych stykow
	while ((klaw1 == 0) && (klaw2 == 1) && (klaw3 == 0));		//czekaj na puszczenie klawisza ST/SP
	delay (25);													//czekaj z powodu drgajacych stykow
}

void sekundnik () interrupt TF1_VECTOR
{
	++overflow;
	if ((overflow == 3600) && (tr1_mode == 0))
	{
		overflow = 0;
		--sec_time;
		if (sec_time < 0)
		{
			--min_time;
			sec_time = 59;
		}
		if (min_time < 0)
		{
			--hou_time;
			min_time = 59;
		}
		if (tmp_dspl > 0) --tmp_dspl;
		if (tmp_dspl == 0) light = 0;
		LCDtime ();
	}
}

void beeper () interrupt TF0_VECTOR
{
	if (blk_beep == 1)
	{
		++ov1_beep;
		if (ov1_beep == 180) NE555 = 0;
		if (ov1_beep == 360)
		{
			NE555 = 1;
			ov1_beep = 0;
		}
	}
	if (blk_ledr == 1)
	{
		++ov1_beep;
		if (ov1_beep == 450) led_r = 0;
		if (ov1_beep == 900)
		{
			led_r = 1;
			ov1_beep = 0;
		}
	}
	if (blk_disp == 1)
	{
		++ov2_beep;
		if (ov2_beep == 900) light = 0;
		if (ov2_beep == 1800)
		{
			light = 1;
			ov2_beep = 0;
		}
	}
	if (blk_en57 == 1)
	{
		++ov3_beep;
		if (ov3_beep == 10)	NE555 = 0;
		if (ov3_beep == 40)
		{
			NE555 = 1;
			ov3_beep = 0;
		}
	}
}

void main ()
{
	klaw1 = 1; klaw2 = 1; klaw3 = 1;							//ustaw logiczne "1" na wejsciach klawiatury
	foto1 = 1; foto2 = 1;										//ustaw logiczne "1" na wejsciach ukladu pomiaru V
	klucz = 1; guzik = 1;										//ustaw logiczne "1" na stacyjke i guzik ladowania
	LM_p1 = 1; LM_p7 = 1;										//ustaw logiczne "1" na wyjsciach komparatora LM393

	lizer = 0; ladow = 0;										//wylacz obydwa styczniki
	light = 1; NE555 = 0;										//wylacz NE555 i podswietl LCD
	led_r = 0; led_g = 0;										//wygas czerwona i jedna zielona diode LED

	EA = 0x01;													//uaktywnij obsluge przerwan
	ET0 = 0x01; ET1 = 0x01;										//wlacz obsluge przerwan od timerow
	PT1 = 0x01;													//timer sekundnika na wyzszy priorytet
	TH0 = 0x00; TH1 = 0x00;										//wartosci startowe TR0 i TR1
	TMOD = 0x22;												//tryb pracy: TR0-2 i TR1-2
	TR0 = 0x01;													//start timera sygnalizacji
	
	lcdscode (0x33);											//inicjacja LCD
	delay (10);
	LCDclear ();												//wyczysc LCD
	lcdwrite_text ("ER02-001");									//wyswietl powitalny komunikat
	_asm;
	        mov		  dpl, #0xFA								//ustaw argument podprogramu delay na 250
			mov        r2, #0x06								//licznik powtorzen ustaw na 6
	10001$:	lcall          _delay								//czekaj 250ms
			djnz       r2, 10001$								//zmniejsz r2 i zapetlaj gdy wiekszy od 0
	_endasm;
	light = 0;
	while (klucz == 1)											//zatrzymaj prace jak nie ma klucza
	{
		led_g = 0;
	}
	led_g = 1;
	while (1)
	{
		settimerproc:
		settimer ();
		lizer = 1;												//wlacz stycznik elektrolizera
		if (!((hou_time == 0) && (min_time == 0) && (sec_time == 0)))
		{
			light = 0;
			TR1 = 0x01;											//start TR1
			while (((hou_time > 0) || (min_time > 0) || (sec_time > 0)) && !(klawisze == 6))
			{
				keyscan ();
				if (klawisze == 1)								//wlacz light na 5 sekund
				{
					tmp_dspl = 5;
					light = 1;
				}
				if (klawisze == 5)								//obsluga ST/SP podczas odliczania
				{
					while ((klaw1 == 0) && (klaw2 == 1) && (klaw3 == 0));
					delay (25);									
					TR1 = 0x00;									//stop RT1 - timer
					lizer = 0;
					blk_disp = 1;
					settimer ();
					light = 0;
					blk_disp = 0;
					TR1 = 0x01;
					lizer = 1;
				}
				while (klucz == 1)								//zatrzymaj prace jak nie ma klucza
				{
					TR1 = 0x00;
					light = 0;
					led_g = 0;
					lizer = 0;
				}	
				TR1 = 0x01;
				led_g = 1;
				lizer = 1;
			}
			TR1 = 0x00;											//stop TR1
			lizer = 0;											//wylacz elektolizer
			LCDtime ();											//potrzebne by wyswietlic stan 00:00:00
			while ((klaw1 == 1) && (klaw2 == 0) && (klaw3 == 0));
			if ((hou_time == 0) && (min_time == 0) && (sec_time == 0))
			{
				TH0 = 0x00;
				blk_disp = 1;
				blk_beep = 1;
				while (klawisze != 1)							//czekaj na zbicie sygnalu konca czasu
				{
					keyscan ();
					while (klucz == 1)							//zatrzymaj prace jak nie ma klucza
					{
						blk_disp = 0;
						blk_beep = 0;
						led_g = 0;
						NE555 = 0;
						light = 0;
					}
					blk_disp = 1;
					blk_beep = 1;
					led_g = 1;
				}
				blk_disp = 0;
				blk_beep = 0;
				NE555 = 0;
				light = 1;
				lcdwrite_text (" GOTOWY ");						//komunikat po zbiciu alarmu
				lightwait ();
			}
			else
			{	
				lcdwrite_text ("  STOP  ");						//komunikat po zatrzymaniu timera
				lightwait ();
				lcdwrite_text (" GOTOWY ");
				lightwait ();
			}
		}
		else
		{
			lcdwrite_text (" RECZNY ");							//komunikat pracy bez nastawy timera
			lightwait ();
		}
		liz_tmp1 = lizer;
		while (guzik == 1)
		{
			while (klucz == 1)
			{
				led_g = 0;
				lizer = 0;
			}
			lizer = liz_tmp1;
			led_g = 1;
			if ((klaw1 == 1) && (klaw2 == 0) && (klaw3 == 0))
			{
				delay (25);
				while ((klaw1 == 1) && (klaw2 == 0) && (klaw3 == 0));
				hou_time = 0;
				min_time = 0;
				sec_time = 0;
				lizer = 0;
				goto settimerproc;
			}
		}
		lizer = 0;
		ladow = 1;
		delay (1);
		lcdscode (0x33);										//inicjacja LCD
		delay (10);
		LCDclear ();
		lcdwrite_text (" LADUJE ");
		overflow = 0;
		delay (15);
		while (guzik == 0)										//trzymane ladowanie
		{
			led_g = 1;
			ladow = 1;
			while (klucz == 1)									//zatrzymaj jak nie ma klucza
			{
				blk_ledr = 0;
				led_g = 0;
				ladow = 0;
				NE555 = 0;
				if (LM_p7 == 1) led_r = 1;
				else led_r = 0;
			}
			if (LM_p1 == 1)										//naladowany do U zaplonu
			{
				blk_ledr = 0;									//wylacz miganie czerwonego leda
				blk_en57 = 1;
				led_r = 1;
				light = 1;
				lcdwrite_text (" GOTOWY ");
				overflow = 0;
				tr1_mode = 1;
				TH1 = 0xC0;										//ustaw timer by mial 14400 przepelnien na sekunde
				vel_disp = 0;
				while (foto1 == 1)
				{
					if (guzik == 1) goto discharge;
				}
				TR1 = 0x01;
				blk_en57 = 0;
				NE555 = 0;
				while (foto2 == 1)
				{
					if (guzik == 1) goto discharge;
				}
				TR1 = 0x00;
				tr1_mode = 0;
				vel_disp = 1;
				goto discharge;
			}
			if (LM_p1 == 0)										//spadek U podczas ladowania
			{
				blk_ledr = 1;
				blk_en57 = 0;
				NE555 = 0;
			}
		}
		discharge:
		blk_ledr = 0;											//wylacz miganie czerwonego leda
		TR1 = 0x00;												//stop licznika predkosci jak puszcono guzik
		TH1 = 0x00;												//wznow przeladowywanie TR1 wartoscia 0
		blk_en57 = 0;
		NE555 = 0;												//wylacz buczka jak wlaczony
		ladow = 0;												//wylacz stycznik ladowania
		delay (1);
		if (LM_p7 == 1) led_r = 1;								//wlacz czerwona diode jak napiecie jest duze
		blk_ledr = 0;
		if (vel_disp == 1)
		{
			if (overflow != 0)
			{
				overflow = 57600 / overflow;
			}
			lcdscode (0x33);									//inicjacja LCD
			delay (10);
			LCDclear ();
			delay (1);
			LCD_buff[0] = 'V'; 
			LCD_buff[1] = '=';
			LCD_buff[2] = ((overflow % 100000) / 10000) + 0x30;
			LCD_buff[3] = ((overflow % 10000) / 1000) + 0x30;
			LCD_buff[4] = ((overflow % 1000) / 100) + 0x30;
			LCD_buff[5] = ((overflow % 100) / 10) + 0x30;
			LCD_buff[6] = '.';
			LCD_buff[7] = (overflow % 10) + 0x30;
			lcdwrite_buff ();
		}
		overflow = 0;											//wyzeruj zmienna overflow by nie klamal timer
		lcdscode (0x33);										//inicjacja LCD
		delay (10);
		LCDclear ();
		delay (1);
		lcdwrite_buff ();
		while (LM_p7 == 1);										//czekaj az spadnie U ponizej dolnego progu
		led_r = 0;
		delay (5);
		while (vel_disp == 1)									//czekaj na nacisniecie guzika RESET
		{
			if ((klaw1 == 1) && (klaw2 == 1) && (klaw3 == 0))
			{
				vel_disp = 0;
			}
		}
		vel_disp = 0;
		hou_time = 0;
		min_time = 0;
		sec_time = 0;
	}
}
